/*
 *  Copyright (C) 2014 Andreas Steinmetz <ast@domdv.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <netinet/in.h>

#define HOSTLEN 64

union a4a6
{
	struct sockaddr_in a4;
	struct sockaddr_in6 a6;
	struct
	{
		int family;
		int port;
		char host[HOSTLEN];
	} dns;
};

struct ctx;

extern int io(void *parm,unsigned char *data,int len,int mode);
extern int mklisten(int port);
extern int doaccept(int fd,union a4a6 *src,union a4a6 *dst);
extern struct ctx *doconnect(union a4a6 *dst,int mark,int timeout,char *cacert);
extern void doclose(struct ctx *ctx);
extern int dotransfer(int s1,struct ctx *ctx,int dump);
extern int addrcmp(union a4a6 *src,union a4a6 *dst,int port);
extern void addr2str(union a4a6 *addr,char *str,int *port);
extern int inet_xton(char *addr,char *port,union a4a6 *dst);
extern int netinit(void);
extern void netexit(void);
